#!/usr/bin/env python
# pygame + PyOpenGL version of Nehe's OpenGL lesson02
# Paul Furber 2001 - m@verick.co.za

import os
import sys

from OpenGL.GL import *
from OpenGL.GLU import *

#from psyco.classes import *

import pygame
import string
from pygame.locals import *
from pygame.font import *
import profile
import Numeric as N
import time
import profile
from random import Random


VERSION = 0.1

#import-classes

screenx = 800
screeny = 600

classes = []
tmp = obj();tmp.rand(487,20.0);tmp.set_pos(0.0,0.0,-20.0); print "Rand: ",tmp.get_count();classes.append(tmp)
tmp = obj();tmp.load("Data/Tube.txt");tmp.set_pos(0.0,0.0,-20.0); print "Tube: ",tmp.get_count();classes.append(tmp)
tmp = obj();tmp.line(487,0.1);tmp.set_pos(0.0,0.0,-20.0); print "Line: ",tmp.get_count();classes.append(tmp)
tmp = obj();tmp.load("Data/Torus.txt");tmp.set_pos(0.0,0.0,-20.0); print "Torus: ",tmp.get_count();classes.append(tmp)
tmp = obj();tmp.quad(487,0.05);tmp.set_pos(0.0,0.0,-30.0); print "Quad: ",tmp.get_count();classes.append(tmp)
tmp = obj();tmp.load("Data/Sphere.txt");tmp.set_pos(0.0,0.0,-20.0); print "sphere: ",tmp.get_count();classes.append(tmp)
tmp = obj();tmp.rand(487,40.0);tmp.set_pos(0.0,0.0,-20.0); print "Rand: ",tmp.get_count();classes.append(tmp)


class anime:

    def __init__(self):
	pass

    def resize(self,(width, height)):
	if height==0:
    	    height=1

	glViewport(0, 0, width, height)
	glMatrixMode(GL_PROJECTION)

        glLoadIdentity()
	gluPerspective(45, 1.0*width/height, 0.5, 150.0)
        glMatrixMode(GL_MODELVIEW)
	glLoadIdentity()

    def init(self):

	glShadeModel(GL_SMOOTH)
	glClearColor(0.0, 0.0, 0.0, 0.5)
	glClearDepth(1.0)
	glEnable(GL_DEPTH_TEST)
        glDepthFunc(GL_LEQUAL)
        glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)
        glBlendFunc(GL_SRC_ALPHA,GL_ONE)
	glEnable(GL_TEXTURE_2D)
#	glLineWidth(2)
#	glEnable(GL_LINE_SMOOTH)
#	glLineStipple(1,2)
	self.rot = 0	
	self.morph = [-1,400]
	
    def desktop(self):
    
	self.rot+=1
#	if (self.rot >=360): 
#	    self.rot=0
	
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT)
	glLoadIdentity()
#	sphere.rotate(self.rot,self.rot,self.rot*-1)
#	sphere.draw_points()

#	tube.rotate(self.rot,self.rot,self.rot)
#	tube.draw_points()

#	torus.draw_points()
#	tube.draw_points()

	self.helper.rotate(self.rot*0.1,self.rot*0.3,self.rot*0.4)
#	self.helper.draw_points()
	if (self.do_morph == 1):
	    self.morph = self.helper.morph(self.helper2,self.morph)	
	    if (self.morph[0] == -1):
		self.do_morph=0
#		self.helper = self.helper2
	else:
	    self.helper.draw_points()


					
    def main(self):

        video_flags = OPENGL|DOUBLEBUF|RLEACCEL|HWACCEL
    
        pygame.init()
        pygame.display.set_mode((screenx,screeny), video_flags)
        pygame.mouse.set_visible(0)
        self.resize((screenx,screeny))
        self.init()
    
        frames = 0
        ticks = pygame.time.get_ticks()
	self.helper = classes[0]
	self.helper2 = classes[1]
	self.classes = 2

	self.do_morph=0


        while 1:

    	    event = pygame.event.poll()
    	    if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
        	break
	    elif (event.type == KEYDOWN and event.key == K_TAB):
		pygame.display.toggle_fullscreen()        
	    elif (event.type == KEYDOWN and event.key == K_SPACE):
		if (self.morph[0] == -1 ):
		    self.morph = [-1,400]
		    self.do_morph = 1
		    print self.classes
		    self.helper2 = classes[self.classes]
		    self.classes+=1
		    if (self.classes >=len(classes)):
			self.classes=1
		
	    keystate = pygame.key.get_pressed()
	    self.desktop()
	    pygame.display.flip()
	    frames = frames + 1
#	    time.sleep(.003)

	print "fps:  %d" % ((frames*1000)/(pygame.time.get_ticks()-ticks))

anime = anime()

profile.run('anime.main()')

